/*
Edité avec le créateur de plugin MuseScore3
Michel Come (2019/2020)
Accordéon diatonique Sol/Do 21 touches sur deux rangées.
*/

import QtQuick 2.0
import MuseScore 3.0
MuseScore 
{
version: "3.3.4"
description: "Editer une tablature d'accordéon diatonique Sol/Do"
menuPath: "Plugins.Personnaliser la tablature"

// Faire un curseur à la position (en ticks MIDI)
function riouagne(position)
{
var Crs = curScore.newCursor();
Crs.rewind(0) ;
while ( Crs.segment.tick < position ){ Crs.next();}
return Crs ;
}

      onRun:         
      {  
      if (typeof curScore === 'undefined')Qt.quit();
      var Select = curScore.selection.elements;
            if (Select.length > 0)  // il y a quelquechose de sélectionné
            {
                  if (Select[0].type == Element.STAFF_TEXT && Select[0].offsetY == 11.5)
                  {
                  // L'élément sélectionné est un accord
                        switch (Select[0].text)
                        {
                        case "A": Select[0].text = "a" ; break ;
                        case "C": Select[0].text = "c" ; break ;
                        case "D": Select[0].text = "d" ; break ;
                        case "E": Select[0].text = "e" ; break ;
                        case "F": Select[0].text = "f" ; break ;
                        case "G": Select[0].text = "g" ; break ;
                        case "a": Select[0].text = "A" ; break ;
                        case "c": Select[0].text = "C" ; break ;
                        case "d": Select[0].text = "D" ; break ;
                        case "e": Select[0].text = "E" ; break ;
                        case "f": Select[0].text = "F" ; break ;
                        case "g": Select[0].text = "G" ; break ;
                        }
                  }
                  else  // L'élément sélectionné est une note ou un numéro de touche
                  {
                  var Select0 = Select[0].parent;
                  if ( Select0.type == Element.CHORD ){var Pointeur = Select0.parent.tick;}
                  if ( Select0.type == Element.SEGMENT ){var Pointeur = Select0.tick;}
                  var Curseur = riouagne(Pointeur) ; // rewind(1) ça marche pas !
                  var Numero = 0 ;
                  var Sens = 0 ;
                  var PT = "P" ; // par défaut
                        for (var Chaque = 0; Chaque < Curseur.segment.annotations.length ; Chaque ++)
                        {
                        var ChaquAnnot = Curseur.segment.annotations[Chaque];
                              if (ChaquAnnot.type == Element.STAFF_TEXT )
                              {
                              Sens = ChaquAnnot.offsetY ;
                                    if ( Sens < 11.5)
                                    {
                                    Numero = ChaquAnnot.text ;
                                    if (Sens == 6) {PT = "P"} else {PT = "T"}
                                    var NumPT = Numero + PT ;
                                          switch (NumPT)
                                          {
                                          case "1'P": ChaquAnnot.text = "1" ; ChaquAnnot.offsetY = 2.5 ; break ;  //52 Mi
                                          case "1T": ChaquAnnot.text = "1'" ; ChaquAnnot.offsetY = -2.5 ; break ; //52 Mi
                                          case "4P": ChaquAnnot.text = "2'" ; ChaquAnnot.offsetY = 2.5; break ;   //59 Si
                                          case "2'T": ChaquAnnot.text = "4" ; ChaquAnnot.offsetY = -2.5 ; break ; //59 Si
                                          case "3'P": ChaquAnnot.text = "4" ; ChaquAnnot.offsetY = 2.5 ; break ;  //60 Do
                                          case "4T": ChaquAnnot.text = "3'" ; ChaquAnnot.offsetY = -2.5 ; break ; //60 Do
                                          case "5P": ChaquAnnot.text = "3'" ; ChaquAnnot.offsetY = 2.5 ; break ;  //62 Ré
                                          case "3'T": ChaquAnnot.text = "5" ; ChaquAnnot.offsetY = -2.5 ; break ; //62 Ré
                                          case "4'P": ChaquAnnot.text = "5" ; ChaquAnnot.offsetY = 2.5 ; break ;  //64 Mi
                                          case "5T": ChaquAnnot.text = "4'" ; ChaquAnnot.offsetY = -2.5 ; break ; //64 Mi
                                          case "6P": ChaquAnnot.text = "5'" ; break ;                             //67 Sol
                                          case "5'P": ChaquAnnot.text = "6" ; break ;                             //67 Sol
                                          case "7P": ChaquAnnot.text = "6'" ; ChaquAnnot.offsetY = 2.5 ; break ;  //71 Si
                                          case "6'T": ChaquAnnot.text = "7" ; ChaquAnnot.offsetY = -2.5 ; break ; //71 Si
                                          case "6'P": ChaquAnnot.text = "8" ; ChaquAnnot.offsetY = 2.5 ; break ;  //72 Do
                                          case "8T": ChaquAnnot.text = "6'" ; ChaquAnnot.offsetY = -2.5 ; break ; //72 Do
                                          case "8P": ChaquAnnot.text = "7" ; ChaquAnnot.offsetY = 2.5 ; break ;   //74 Ré
                                          case "7T": ChaquAnnot.text = "8" ; ChaquAnnot.offsetY = -2.5 ; break ;  //74 Ré
                                          case "7'P": ChaquAnnot.text = "9" ; ChaquAnnot.offsetY = 2.5 ; break ;  //76 Mi
                                          case "9T": ChaquAnnot.text = "7'" ; ChaquAnnot.offsetY = -2.5 ; break ; //76 Mi
                                          case "8'P": ChaquAnnot.text = "9" ; break ;                             //79 Sol
                                          case "9P": ChaquAnnot.text = "8'" ; break ;                             //79 Sol
                                          case "11T": ChaquAnnot.text = "9'" ; break ;                            //81 La
                                          case "9'T": ChaquAnnot.text = "11" ; break ;                            //81 La
                                          case "10P": ChaquAnnot.text = "10'" ; ChaquAnnot.offsetY = 2.5 ; break ;//83 Si
                                          case "10'T": ChaquAnnot.text = "10" ; ChaquAnnot.offsetY = -2.5 ; break;//83 Si
                                          }
                                    Sens = ChaquAnnot.offsetY ;
                                    if (Sens == 6) {PT = "P"} else {PT = "T"}            
                                    } // Numéro de touche (main gauche). 
                                    else // Sinon: Lettre d'accord/basse (main droite)
                                    {
                                    var AcPT = ChaquAnnot.text + PT
                                          switch (AcPT)
                                          {
                                          // conflit accord/sens
                                          case "AP": ChaquAnnot.text = "E";   break ;
                                          case "CT": ChaquAnnot.text = "G";   break ;
                                          case "DP": ChaquAnnot.text = "G";   break ;
                                          case "ET": ChaquAnnot.text = "A";   break ;
                                          case "GT": ChaquAnnot.text = "D";   break ;
                                          case "GP": ChaquAnnot.text = "C";   break ;
                                          case "aP": ChaquAnnot.text = "e";   break ;
                                          case "cT": ChaquAnnot.text = "g";   break ;
                                          case "dP": ChaquAnnot.text = "g";   break ;
                                          case "eT": ChaquAnnot.text = "a";   break ;
                                          case "gT": ChaquAnnot.text = "d";   break ;
                                          case "gP": ChaquAnnot.text = "c";   break ;
                                          } // résolution de conflit
                                    } // Main gauche et main droite           
                              }
                        } // Chaque annotation de ce segment
                  } // accord sélectionné
            } // s'il y avait quelquechose de sélectionné
      Qt.quit();
      }     // Run
}     // MuseScore
